/*gruntfile.js*/

module.exports = function(grunt) {

  require('load-grunt-tasks')(grunt);

  grunt.initConfig({
    pkg: grunt.file.readJSON('package.json'),

    watch: {

      babel: {
				files: ['*.js','./src/*.js'],
				tasks: ['babel']
			},

      mochaTest: {
				files: ['*.js', './tests/*.js', './src/*.js'],
				tasks: ['mochaTest']
			}
    },

    babel: {
        options: {
            sourceMap: true,
            presets: ['es2015']
        },
        dist: {
            files: {
                'dist/bsshortify.js': 'src/bsshortify-es6.js'
            }
        }
    },

    mochaTest: {
      test: {
        options: {
          reporter: 'spec'
        },
        src: ['test.js']
      }
    }

  });

  grunt.loadNpmTasks('grunt-contrib-watch');
  grunt.loadNpmTasks('grunt-mocha-test');

  grunt.registerTask('test', ['mochaTest']);
  grunt.registerTask('default', ['babel']);

};
