'use strict';

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _ = require('lodash');

var bs = {};

bs.bColumn = function () {
  var def_xs = arguments.length <= 0 || arguments[0] === undefined ? 12 : arguments[0];
  var def_sm = arguments.length <= 1 || arguments[1] === undefined ? def_xs : arguments[1];
  var def_md = arguments.length <= 2 || arguments[2] === undefined ? def_sm : arguments[2];
  var def_lg = arguments.length <= 3 || arguments[3] === undefined ? def_md : arguments[3];


  return function () {
    var xs = arguments.length <= 0 || arguments[0] === undefined ? def_xs : arguments[0];
    var sm = arguments.length <= 1 || arguments[1] === undefined ? def_sm : arguments[1];
    var md = arguments.length <= 2 || arguments[2] === undefined ? def_md : arguments[2];
    var lg = arguments.length <= 3 || arguments[3] === undefined ? def_lg : arguments[3];

    return shortify('', xs, sm, md, lg);
  };
};

bs.bOffset = function () {
  var def_xs = arguments.length <= 0 || arguments[0] === undefined ? 1 : arguments[0];
  var def_sm = arguments.length <= 1 || arguments[1] === undefined ? def_xs : arguments[1];
  var def_md = arguments.length <= 2 || arguments[2] === undefined ? def_sm : arguments[2];
  var def_lg = arguments.length <= 3 || arguments[3] === undefined ? def_md : arguments[3];


  return function () {
    var xs = arguments.length <= 0 || arguments[0] === undefined ? def_xs : arguments[0];
    var sm = arguments.length <= 1 || arguments[1] === undefined ? def_sm : arguments[1];
    var md = arguments.length <= 2 || arguments[2] === undefined ? def_md : arguments[2];
    var lg = arguments.length <= 3 || arguments[3] === undefined ? def_lg : arguments[3];

    return shortify('offset-', xs, sm, md, lg);
  };
};

bs.bPush = function () {
  var def_xs = arguments.length <= 0 || arguments[0] === undefined ? 1 : arguments[0];
  var def_sm = arguments.length <= 1 || arguments[1] === undefined ? def_xs : arguments[1];
  var def_md = arguments.length <= 2 || arguments[2] === undefined ? def_sm : arguments[2];
  var def_lg = arguments.length <= 3 || arguments[3] === undefined ? def_md : arguments[3];


  return function () {
    var xs = arguments.length <= 0 || arguments[0] === undefined ? def_xs : arguments[0];
    var sm = arguments.length <= 1 || arguments[1] === undefined ? def_sm : arguments[1];
    var md = arguments.length <= 2 || arguments[2] === undefined ? def_md : arguments[2];
    var lg = arguments.length <= 3 || arguments[3] === undefined ? def_lg : arguments[3];

    return shortify('push-', xs, sm, md, lg);
  };
};

bs.bPull = function () {
  var def_xs = arguments.length <= 0 || arguments[0] === undefined ? 1 : arguments[0];
  var def_sm = arguments.length <= 1 || arguments[1] === undefined ? def_xs : arguments[1];
  var def_md = arguments.length <= 2 || arguments[2] === undefined ? def_sm : arguments[2];
  var def_lg = arguments.length <= 3 || arguments[3] === undefined ? def_md : arguments[3];


  return function () {
    var xs = arguments.length <= 0 || arguments[0] === undefined ? def_xs : arguments[0];
    var sm = arguments.length <= 1 || arguments[1] === undefined ? def_sm : arguments[1];
    var md = arguments.length <= 2 || arguments[2] === undefined ? def_md : arguments[2];
    var lg = arguments.length <= 3 || arguments[3] === undefined ? def_lg : arguments[3];

    return shortify('pull-', xs, sm, md, lg);
  };
};

module.exports = bs;

function shortify(prefix, xs, sm, md, lg) {

  var bClass = '';
  var xs = xs;sm = sm;md = md;lg = lg;

  //check if it is a plain object with xs,sm,md,lg keys only
  if (_.isPlainObject(xs)) {
    var obj = xs;
    var arr = _.keys(obj);
    var check_arr = _.difference(arr, ['xs', 'sm', 'md', 'lg']);

    if (check_arr.length !== 0) {
      throw new Error("BSshortify: incorrect keys " + check_arr + ", should be each of " + arr);
    }

    var _xs = xs;
    var xs = _xs.xs;
    var sm = _xs.sm;
    var md = _xs.md;
    var lg = _xs.lg;
  }

  //check if the first argument is a space separated list of values ie. ("12 12 6 6")
  if (_.isString(xs)) {
    var checkIfList = xs.split(" ") || false;

    if (checkIfList.length === 4) {
      xs = checkIfList;
    } else if (checkIfList && checkIfList.length !== 1) {
      throw new Error("BSshortify: incorrect number of space-separated arguments or a space that needs to be deleted");
    }
  }

  //turn the arguments into numbers in case they were passed in as strings i.e. ("12","12","6","6")
  //so that they can be cought by isNumber option, later, downstream

  if (_.isString(xs) || _.isString(sm) || _.isString(md) || _.isString(lg)) {
    xs = parseInt(xs);
    sm = parseInt(sm);
    md = parseInt(md);
    lg = parseInt(lg);
  }

  //destructure the array argument into variables xs,sm,md,lg that are numbers.
  if (_.isArray(xs)) {

    xs = xs.map(function (v) {
      return parseInt(v);
    });

    var _xs2 = xs;

    var _xs3 = _slicedToArray(_xs2, 4);

    var xs = _xs3[0];
    var sm = _xs3[1];
    var md = _xs3[2];
    var lg = _xs3[3];
  }

  //by now there should be 4 aruments (xs,sm,md,lg) that are numbers
  if (_.isNumber(xs) || _.isNumber(sm) || _.isNumber(md) || _.isNumber(lg)) {

    var suffix_xs = prefix + xs;
    var suffix_sm = prefix + sm;
    var suffix_md = prefix + md;
    var suffix_lg = prefix + lg;

    bClass += xs ? ' col-xs-' + suffix_xs : '';
    bClass += sm ? ' col-sm-' + suffix_sm : '';
    bClass += md ? ' col-md-' + suffix_md : '';
    bClass += lg ? ' col-lg-' + suffix_lg : '';

    bClass = bClass.trim(); //remove spaces at the begining and at the end
  } else {
      throw new Error("BSshortify: there seems to be something wrong with the arguments");
    }

  return bClass;
};
//# sourceMappingURL=bsshortify.js.map
