var expect = require('chai').expect;
var _c = require('../dist/bsshortify').bColumn(12,11,10,9);

module.exports = function(){

  describe('Bootstrap Columns', function() {

    it('turns 4 string arguments into proper bootstrap classes ' , function(){
      expect(_c('12','12','6','4')).to.equal('col-xs-12 col-sm-12 col-md-6 col-lg-4');
    });

    it('turns 4 number arguments into proper bootstrap classes ' , function(){
      expect(_c(12,10,8,4)).to.equal('col-xs-12 col-sm-10 col-md-8 col-lg-4');
    });

    it('turns 4 mixed number & string arguments into proper bootstrap classes ' , function(){
      expect(_c('12',10,'8',4)).to.equal('col-xs-12 col-sm-10 col-md-8 col-lg-4');
    });

    it('turns an array argument into proper bootstrap classes ' , function(){

      expect(_c([6,12,5,6])).to.equal('col-xs-6 col-sm-12 col-md-5 col-lg-6');
      expect(_c(['6','12','5','6'])).to.equal('col-xs-6 col-sm-12 col-md-5 col-lg-6');
      expect(_c([6,'12',5,'6'])).to.equal('col-xs-6 col-sm-12 col-md-5 col-lg-6');

    });

    it('turns an object argument into proper bootstrap classes ' , function(){
      var obj = { xs: 12, sm: 10, md: 8, lg: 4 };
      var obj2 = { xs: '12', sm: '10', md: '8', lg: '4' };
      expect(_c(obj)).to.equal('col-xs-12 col-sm-10 col-md-8 col-lg-4');
      expect(_c(obj2)).to.equal('col-xs-12 col-sm-10 col-md-8 col-lg-4');
    });

    it('checks the user provided defaults and renders them when no arguments ' , function(){
      expect(_c()).to.equal('col-xs-12 col-sm-11 col-md-10 col-lg-9');
    });

    it('if any of the arguments is 0 then the relevant class is omitted ' , function(){

      var str = 'col-xs-12 col-lg-9';

      expect(_c(12,0,0,9)).to.equal(str);
      expect(_c('12','0','0','9')).to.equal(str);
      expect(_c([12,0,0,9])).to.equal(str);
      expect(_c({ xs:12, sm: 0, md: 0, lg: 9 })).to.equal(str);
    });


  });

};
