var expect = require('chai').expect;
var _o = require('../dist/bsshortify').bOffset(12,11,10,9);

module.exports = function(){

  describe('Bootstrap Offsets', function() {

    it('turns 4 string arguments into proper bootstrap classes ' , function(){
      expect(_o('12','12','6','4')).to.equal('col-xs-offset-12 col-sm-offset-12 col-md-offset-6 col-lg-offset-4');
    });

    it('turns 4 number arguments into proper bootstrap classes ' , function(){
      expect(_o(12,10,8,4)).to.equal('col-xs-offset-12 col-sm-offset-10 col-md-offset-8 col-lg-offset-4');
    });

    it('turns 4 mixed number & string arguments into proper bootstrap classes ' , function(){
      expect(_o('12',10,'8',4)).to.equal('col-xs-offset-12 col-sm-offset-10 col-md-offset-8 col-lg-offset-4');
    });

    it('turns an array argument into proper bootstrap classes ' , function(){

      expect(_o([6,12,5,6])).to.equal('col-xs-offset-6 col-sm-offset-12 col-md-offset-5 col-lg-offset-6');
      expect(_o(['6','12','5','6'])).to.equal('col-xs-offset-6 col-sm-offset-12 col-md-offset-5 col-lg-offset-6');
      expect(_o([6,'12',5,'6'])).to.equal('col-xs-offset-6 col-sm-offset-12 col-md-offset-5 col-lg-offset-6');

    });

    it('turns an object argument into proper bootstrap classes ' , function(){
      var obj = { xs: 12, sm: 10, md: 8, lg: 4 };
      var obj2 = { xs: '12', sm: '10', md: '8', lg: '4' };
      expect(_o(obj)).to.equal('col-xs-offset-12 col-sm-offset-10 col-md-offset-8 col-lg-offset-4');
      expect(_o(obj2)).to.equal('col-xs-offset-12 col-sm-offset-10 col-md-offset-8 col-lg-offset-4');
    });

    it('checks the user provided defaults and renders them when no arguments ' , function(){
      expect(_o()).to.equal('col-xs-offset-12 col-sm-offset-11 col-md-offset-10 col-lg-offset-9');
    });


  });

};
