var expect = require('chai').expect;
var _pl = require('../dist/bsshortify').bPull(12,11,10,9);

module.exports = function(){

  describe('Bootstrap Pull', function() {

    it('turns 4 string arguments into proper bootstrap classes ' , function(){
      expect(_pl('12','12','6','4')).to.equal('col-xs-pull-12 col-sm-pull-12 col-md-pull-6 col-lg-pull-4');
    });

    it('turns 4 number arguments into proper bootstrap classes ' , function(){
      expect(_pl(12,10,8,4)).to.equal('col-xs-pull-12 col-sm-pull-10 col-md-pull-8 col-lg-pull-4');
    });

    it('turns 4 mixed number & string arguments into proper bootstrap classes ' , function(){
      expect(_pl('12',10,'8',4)).to.equal('col-xs-pull-12 col-sm-pull-10 col-md-pull-8 col-lg-pull-4');
    });

    it('turns an array argument into proper bootstrap classes ' , function(){

      expect(_pl([6,12,5,6])).to.equal('col-xs-pull-6 col-sm-pull-12 col-md-pull-5 col-lg-pull-6');
      expect(_pl(['6','12','5','6'])).to.equal('col-xs-pull-6 col-sm-pull-12 col-md-pull-5 col-lg-pull-6');
      expect(_pl([6,'12',5,'6'])).to.equal('col-xs-pull-6 col-sm-pull-12 col-md-pull-5 col-lg-pull-6');

    });

    it('turns an object argument into proper bootstrap classes ' , function(){
      var obj = { xs: 12, sm: 10, md: 8, lg: 4 };
      var obj2 = { xs: '12', sm: '10', md: '8', lg: '4' };
      expect(_pl(obj)).to.equal('col-xs-pull-12 col-sm-pull-10 col-md-pull-8 col-lg-pull-4');
      expect(_pl(obj2)).to.equal('col-xs-pull-12 col-sm-pull-10 col-md-pull-8 col-lg-pull-4');
    });

    it('checks the user provided defaults and renders them when no arguments ' , function(){
      expect(_pl()).to.equal('col-xs-pull-12 col-sm-pull-11 col-md-pull-10 col-lg-pull-9');
    });


  });

};
