var expect = require('chai').expect;
var _ps = require('../dist/bsshortify').bPush(12,11,10,9);

module.exports = function(){

  describe('Bootstrap Push', function() {

    it('turns 4 string arguments into proper bootstrap classes ' , function(){
      expect(_ps('12','12','6','4')).to.equal('col-xs-push-12 col-sm-push-12 col-md-push-6 col-lg-push-4');
    });

    it('turns 4 number arguments into proper bootstrap classes ' , function(){
      expect(_ps(12,10,8,4)).to.equal('col-xs-push-12 col-sm-push-10 col-md-push-8 col-lg-push-4');
    });

    it('turns 4 mixed number & string arguments into proper bootstrap classes ' , function(){
      expect(_ps('12',10,'8',4)).to.equal('col-xs-push-12 col-sm-push-10 col-md-push-8 col-lg-push-4');
    });

    it('turns an array argument into proper bootstrap classes ' , function(){

      expect(_ps([6,12,5,6])).to.equal('col-xs-push-6 col-sm-push-12 col-md-push-5 col-lg-push-6');
      expect(_ps(['6','12','5','6'])).to.equal('col-xs-push-6 col-sm-push-12 col-md-push-5 col-lg-push-6');
      expect(_ps([6,'12',5,'6'])).to.equal('col-xs-push-6 col-sm-push-12 col-md-push-5 col-lg-push-6');

    });

    it('turns an object argument into proper bootstrap classes ' , function(){
      var obj = { xs: 12, sm: 10, md: 8, lg: 4 };
      var obj2 = { xs: '12', sm: '10', md: '8', lg: '4' };
      expect(_ps(obj)).to.equal('col-xs-push-12 col-sm-push-10 col-md-push-8 col-lg-push-4');
      expect(_ps(obj2)).to.equal('col-xs-push-12 col-sm-push-10 col-md-push-8 col-lg-push-4');
    });

    it('checks the user provided defaults and renders them when no arguments ' , function(){
      expect(_ps()).to.equal('col-xs-push-12 col-sm-push-11 col-md-push-10 col-lg-push-9');
    });




  });

};
